#include "include.h"
#include "extern.h"

char *
genchar(n)
int n;
{
#if UNIX
 char *malloc();
#endif
#if VMS
 void *malloc();
#endif

 char *dummy, *end;
 register char *c;

#if UNIX
 dummy = malloc(sizeof(char) * n);
#endif
#if VMS
 dummy = (char*) malloc(sizeof(char) * n);
#endif

 if(dummy == NULL) {
   printf("Not enough memory. Exiting\n");
   exit(-1);
 }
 end = dummy + (n*sizeof(char));
 for(c = dummy; c < end; c++)
   *c = 0;
 return(dummy);
}

entry *
genentry()
{
 char *genchar();
 entry *dummy;
 register int i;

 dummy = (entry *) malloc(sizeof(entry));
 if(dummy == NULL) {
   printf("Not enough memory. Exiting\n");
   exit(-1);
 }
 dummy -> name = NULL;
 dummy -> email = NULL;
 dummy -> system = NULL;
 dummy -> numkeys = 0;
 dummy -> keys = NULL;
 dummy -> comment = NULL;
 dummy -> next = NULL;
 return(dummy);
}


freeall()
{
 register int i;

 printf("Cleaning up..\n");
 curr = head;
 while(curr != NULL) {
   free(curr -> name);
   free(curr -> email);
   free(curr -> system);
   for(i = 0; i < curr -> numkeys; i++) 
     free(curr -> keys[i]);
   free(curr -> numkeys);
   free(curr -> comment);
   free(curr);
   curr = curr -> next;
 }
}

